'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Aside = function (_Component) {
  _inherits(Aside, _Component);

  function Aside(props) {
    _classCallCheck(this, Aside);

    var _this = _possibleConstructorReturn(this, (Aside.__proto__ || Object.getPrototypeOf(Aside)).call(this, props));

    _this.state = { activeTab: 0 };
    _this.toggle = _this.toggle.bind(_this);
    _this._renderNavItems = _this._renderNavItems.bind(_this);
    _this._renderTabPanels = _this._renderTabPanels.bind(_this);
    return _this;
  }

  _createClass(Aside, [{
    key: 'toggle',
    value: function toggle(tab) {
      if (this.state.activeTab !== tab) {
        this.setState({ activeTab: tab });
      }
    }
  }, {
    key: '_renderNavItems',
    value: function _renderNavItems(item, key) {
      var _this2 = this;

      return _react2.default.createElement(
        _reactstrap.NavItem,
        { key: key },
        _react2.default.createElement(
          _reactstrap.NavLink,
          { className: (0, _classnames2.default)({ active: this.state.activeTab === key }), onClick: function onClick() {
              _this2.toggle(key);
            } },
          item.icon && _react2.default.createElement('i', { className: item.icon }),
          item.text && _react2.default.createElement(
            'i',
            null,
            item.text
          )
        )
      );
    }
  }, {
    key: '_renderTabPanels',
    value: function _renderTabPanels(tab, key) {
      return _react2.default.createElement(
        _reactstrap.TabPane,
        {
          key: key,
          className: tab.props.className,
          tabId: key
        },
        tab
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'aside',
        { className: 'aside-menu' },
        _react2.default.createElement(
          _reactstrap.Nav,
          { tabs: true },
          this.props.NavItems.map(this._renderNavItems)
        ),
        _react2.default.createElement(
          _reactstrap.TabContent,
          { activeTab: this.state.activeTab },
          this.props.TabPanels.map(this._renderTabPanels)
        )
      );
    }
  }]);

  return Aside;
}(_react.Component);

Aside.defaultProps = {
  NavItems: [],
  TabPanels: []
};

Aside.propTypes = {
  NavItems: _propTypes2.default.array,
  TabPanels: _propTypes2.default.array
};

exports.default = Aside;