'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDayPicker = require('react-day-picker');

var _reactDayPicker2 = _interopRequireDefault(_reactDayPicker);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Translate month names
var MONTHS = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];

// Translate weekdays header
var WEEKDAYS_SHORT = ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'];

// Translate weekdays header titles
var WEEKDAYS_LONG = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'];

var CalendarYear = function (_Component) {
  _inherits(CalendarYear, _Component);

  function CalendarYear(props) {
    _classCallCheck(this, CalendarYear);

    var _this = _possibleConstructorReturn(this, (CalendarYear.__proto__ || Object.getPrototypeOf(CalendarYear)).call(this, props));

    var year = props.calendarios[0];
    if (props.initCalendario) {
      year = props.initCalendario;
    }

    _this.state = {
      year: year,
      calendarios: []
    };
    _this.showPrevious = _this.showPrevious.bind(_this);
    _this.showNext = _this.showNext.bind(_this);
    _this.handleDayClick = _this.handleDayClick.bind(_this);
    return _this;
  }

  _createClass(CalendarYear, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.calendarios.length !== 0 && this.state.calendarios.length === 0) {
        var year = nextProps.calendarios[0];
        if (nextProps.initCalendario) {
          year = nextProps.initCalendario;
        }

        nextProps.changeCalendario(year);
        this.setState({
          year: year,
          calendarios: nextProps.calendarios
        });
      }
    }
  }, {
    key: 'showPrevious',
    value: function showPrevious() {
      this.props.changeCalendario(this.state.year - 1);
      this.setState({
        year: this.state.year - 1
      });
    }
  }, {
    key: 'showNext',
    value: function showNext() {
      this.props.changeCalendario(this.state.year + 1);
      this.setState({
        year: this.state.year + 1
      });
    }
  }, {
    key: 'handleDayClick',
    value: function handleDayClick(day, modifiers, _ref) {
      var disabled = _ref.disabled,
          selected = _ref.selected;

      if (disabled) {
        return;
      }
      this.props.onSelected && this.props.onSelected((0, _moment2.default)(day));
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'YearCalendar' },
        this.props.calendarios.length !== 0 && _react2.default.createElement(
          'h1',
          null,
          this.props.calendarios[this.props.calendarios.indexOf(this.state.year - 1)] && _react2.default.createElement(
            'a',
            { onClick: this.showPrevious },
            this.state.year - 1
          ),
          this.state.year,
          this.props.calendarios[this.props.calendarios.indexOf(this.state.year + 1)] && _react2.default.createElement(
            'a',
            { onClick: this.showNext },
            this.state.year + 1
          )
        ),
        this.props.calendarios.length !== 0 && _react2.default.createElement('hr', null),
        !this.props.fetching && this.props.fetchingDias && this.props.calendarios.length !== 0 && _react2.default.createElement(_reactDayPicker2.default, {
          locale: 'es',
          months: MONTHS,
          weekdaysLong: WEEKDAYS_LONG,
          weekdaysShort: WEEKDAYS_SHORT,
          onDayClick: this.handleDayClick,
          canChangeMonth: false,
          month: new Date(this.state.year, 0, 1),
          numberOfMonths: 12,
          modifiers: this.props.modifiers,
          renderDay: this.props.renderDay && this.props.renderDay
        }),
        this.props.fetching && _react2.default.createElement(
          'h3',
          { style: { color: '#596464' } },
          'Cargando ...'
        ),
        !this.props.fetching && this.props.calendarios.length === 0 && _react2.default.createElement(
          'p',
          { style: { color: '#596464' } },
          _react2.default.createElement(
            'strong',
            null,
            'No existen calendarios cargados'
          )
        )
      );
    }
  }]);

  return CalendarYear;
}(_react.Component);

CalendarYear.defaultProps = {
  calendarios: []
};

CalendarYear.propTypes = {
  calendarios: _propTypes2.default.array,
  initCalendario: _propTypes2.default.number,
  fetching: _propTypes2.default.bool,
  fetchingDias: _propTypes2.default.bool,
  onSelected: _propTypes2.default.func,
  renderDay: _propTypes2.default.func,
  changeCalendario: _propTypes2.default.func,
  modifiers: _propTypes2.default.object
};

exports.default = CalendarYear;