'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cleanWhiteSpace = cleanWhiteSpace;
exports.toInt = toInt;
exports.toFloat = toFloat;
exports.toBool = toBool;
function cleanWhiteSpace(value) {
  var primerBlanco = /^ /;
  var variosBlancos = /[ ]+/g;
  value = value.replace(variosBlancos, ' ');
  value = value.replace(primerBlanco, '');
  return value;
}

function toInt(value, vDefault) {
  return value !== undefined && value !== '' && !isNaN(Number(value)) ? parseInt(value, 10) : vDefault !== undefined ? vDefault : value;
}

function toFloat(value, vDefault) {
  return value !== undefined && value !== '' && !isNaN(Number(value)) ? parseFloat(value, 10) : vDefault !== undefined ? vDefault : value;
}

function toBool(value) {
  return value === 'true';
}

exports.default = {
  cleanWhiteSpace: cleanWhiteSpace,
  toInt: toInt,
  toFloat: toFloat,
  toBool: toBool
};