'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactMotion = require('react-motion');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Constants
var SPRING_CONFIG = [400, 28];

// Utility functions
function toRadians(degrees) {
  return degrees * 0.0174533;
}

var IconMotionMenu = function (_Component) {
  _inherits(IconMotionMenu, _Component);

  function IconMotionMenu(props) {
    _classCallCheck(this, IconMotionMenu);

    var _this = _possibleConstructorReturn(this, (IconMotionMenu.__proto__ || Object.getPrototypeOf(IconMotionMenu)).call(this, props));

    var button = _react2.default.cloneElement(props.button, {
      ref: function ref(iconMotionMenuBtn) {
        _this.iconMotionMenuBtn = iconMotionMenuBtn;
      },
      onClick: function onClick(e) {
        return _this.toggleMenu(e);
      }
    });

    var childrens = [];
    if (Array.isArray(props.children)) {
      childrens = props.children;
    } else {
      childrens.push(props.children);
    }
    childrens = childrens.filter(function (c) {
      return c;
    });
    var children = childrens.map(function (v, k) {
      v = _react2.default.cloneElement(v, {
        onClick: function onClick() {}
      });
      return v;
    });
    _this.state = {
      isOpen: false,
      button: button,
      childButtons: [],
      children: children,
      baseAngle: '',
      childPosition: { x: 15, y: 15 },
      childrens: childrens
    };
    _this.toggleMenu = _this.toggleMenu.bind(_this);
    _this.closeMenu = _this.closeMenu.bind(_this);
    _this.animateChildButtonsWithDelay = _this.animateChildButtonsWithDelay.bind(_this);
    _this.initialChildButtonStyles = _this.initialChildButtonStyles.bind(_this);
    _this.finalChildButtonStyles = _this.finalChildButtonStyles.bind(_this);
    _this.finalChildDeltaPositions = _this.finalChildDeltaPositions.bind(_this);
    _this.renderChildButton = _this.renderChildButton.bind(_this);
    return _this;
  }

  _createClass(IconMotionMenu, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var childButtons = [];
      this.state.children.map(function (button, index) {
        childButtons.push(_this2.renderChildButton(index));
        return button;
      });
      var element = _reactDom2.default.findDOMNode(this.iconMotionMenuBtn);
      var FAN_ANGLE = this.props.initAngle ? this.props.initAngle : (childButtons.length - 1) * this.props.separationAngle;
      if (element) {
        element.style.position = 'relative';
        element.style.zIndex = 1;
      }
      this.setState({
        childButtons: childButtons,
        baseAngle: (180 - FAN_ANGLE) / 2,
        childPosition: { x: element && element.offsetWidth / 2, y: 15 }
      });
    }
  }, {
    key: 'initialChildButtonStyles',
    value: function initialChildButtonStyles() {
      return {
        width: this.props.childButtonDiam,
        height: this.props.childButtonDiam,
        top: (0, _reactMotion.spring)(this.state.childPosition.y - this.props.childButtonDiam / 2, SPRING_CONFIG),
        left: (0, _reactMotion.spring)(this.state.childPosition.x - this.props.childButtonDiam / 2, SPRING_CONFIG),
        rotate: (0, _reactMotion.spring)(-180, SPRING_CONFIG),
        scale: (0, _reactMotion.spring)(0.5, SPRING_CONFIG),
        zIndex: 0
      };
    }
  }, {
    key: 'finalChildButtonStyles',
    value: function finalChildButtonStyles(childIndex) {
      var _finalChildDeltaPosit = this.finalChildDeltaPositions(childIndex),
          deltaX = _finalChildDeltaPosit.deltaX,
          deltaY = _finalChildDeltaPosit.deltaY;

      return {
        width: this.props.childButtonDiam,
        height: this.props.childButtonDiam,
        top: (0, _reactMotion.spring)(this.state.childPosition.y - deltaY, SPRING_CONFIG),
        left: (0, _reactMotion.spring)(this.state.childPosition.x + deltaX, SPRING_CONFIG),
        rotate: (0, _reactMotion.spring)(0, SPRING_CONFIG),
        scale: (0, _reactMotion.spring)(1, SPRING_CONFIG),
        zIndex: this.props.backlock ? 1042 : 0
      };
    }
  }, {
    key: 'finalChildDeltaPositions',
    value: function finalChildDeltaPositions(index) {
      var angle = this.state.baseAngle + index * this.props.separationAngle;
      var delta = Math.cos(toRadians(angle)) < 0 ? Math.cos(toRadians(angle)) * -1 : Math.cos(toRadians(angle)) * -1;
      return {
        deltaX: this.props.flyOutRadius * delta - this.props.childButtonDiam / 2,
        deltaY: this.props.flyOutRadius * Math.sin(toRadians(angle)) + this.props.childButtonDiam / 2
      };
    }
  }, {
    key: 'toggleMenu',
    value: function toggleMenu(e) {
      var _this3 = this;

      e.stopPropagation();
      this.setState({
        isOpen: !this.state.isOpen
      }, function () {
        var element = _reactDom2.default.findDOMNode(_this3.iconMotionMenuBtn);
        if (_this3.state.isOpen && _this3.props.backlock) {
          element.style.zIndex = 1043;
        } else {
          element.style.zIndex = 1;
        }
        _this3.state.isOpen ? document.body.classList.add('modal-open') : document.body.classList.remove('modal-open');
      });
      this.animateChildButtonsWithDelay();
    }
  }, {
    key: 'closeMenu',
    value: function closeMenu() {
      var _this4 = this;

      this.setState({
        isOpen: false
      }, function () {
        document.body.classList.remove('modal-open');
        var element = _reactDom2.default.findDOMNode(_this4.iconMotionMenuBtn);
        element.style.zIndex = 1;
      });
      this.animateChildButtonsWithDelay();
    }
  }, {
    key: 'animateChildButtonsWithDelay',
    value: function animateChildButtonsWithDelay() {
      var _this5 = this;

      this.state.childButtons.map(function (button, index) {
        var childButtons = _this5.state.childButtons;

        setTimeout(function () {
          if (_this5.props.animate.direccion === 'right') {
            var key = _this5.state.childButtons.length - index - 1;
            childButtons[key] = _this5.renderChildButton(key);
          } else {
            childButtons[index] = _this5.renderChildButton(index);
          }
        }, index * (_this5.props.animate.velocidad ? _this5.props.animate.velocidad : IconMotionMenu.defaultProps.animate.velocidad));
        return button;
      });
    }
  }, {
    key: 'renderChildButton',
    value: function renderChildButton(index) {
      var _this6 = this;

      var style = this.state.isOpen ? this.finalChildButtonStyles(index) : this.initialChildButtonStyles();
      return _react2.default.createElement(
        _reactMotion.Motion,
        { style: style, key: index },
        function (_ref) {
          var width = _ref.width,
              height = _ref.height,
              top = _ref.top,
              left = _ref.left,
              rotate = _ref.rotate,
              scale = _ref.scale,
              zIndex = _ref.zIndex;
          return _react2.default.createElement(
            'div',
            {
              className: 'IconMotionMenu child-button',
              style: {
                width: width,
                height: height,
                top: top,
                left: left,
                transform: 'rotate(' + rotate + 'deg) scale(' + scale + ')',
                zIndex: zIndex
              },
              onClick: function onClick() {
                _this6.state.childrens[index].props.onClick();_this6.closeMenu();
              }
            },
            _this6.state.children[index]
          );
        }
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this7 = this;

      var _state = this.state,
          isOpen = _state.isOpen,
          button = _state.button,
          childButtons = _state.childButtons;

      var mainButtonRotation = isOpen ? { rotate: (0, _reactMotion.spring)(0, [500, 30]) } : { rotate: (0, _reactMotion.spring)(-135, [500, 30]) };
      if (this.state.children.length !== 0) {
        return _react2.default.createElement(
          _reactMotion.Motion,
          { style: mainButtonRotation },
          function (_ref2) {
            var rotate = _ref2.rotate;
            return _react2.default.createElement(
              'wrapper',
              {
                style: {
                  position: 'relative',
                  display: 'inline-block'
                }
              },
              _this7.props.backlock && _react2.default.createElement('div', {
                onClick: function onClick() {
                  return _this7.closeMenu();
                },
                style: {
                  visibility: _this7.state.isOpen ? 'visible' : 'hidden',
                  transition: !_this7.state.isOpen ? 'visibility 0s linear 0.5s,opacity 0.5s linear' : ''
                },
                className: 'modal-backdrop fade ' + (_this7.state.isOpen ? 'show' : '')
              }),
              _react2.default.createElement(
                'wrapper',
                {
                  style: {
                    zIndex: _this7.props.rotateButton ? _this7.props.backlock && _this7.state.isOpen ? 1043 : 1 : 'initial',
                    position: _this7.props.rotateButton ? 'absolute' : 'initial',
                    transform: _this7.props.rotateButton ? 'rotate(' + rotate + 'deg)' : ''
                  }
                },
                button
              ),
              childButtons.map(function (button) {
                return button;
              })
            );
          }
        );
      } else {
        return null;
      }
    }
  }]);

  return IconMotionMenu;
}(_react.Component);

IconMotionMenu.defaultProps = {
  animate: {
    direccion: 'left',
    velocidad: 60
  },
  childButtonDiam: 30,
  separationAngle: 40,
  flyOutRadius: 60,
  backlock: true
};

IconMotionMenu.propTypes = {
  animate: _propTypes2.default.object,
  children: _propTypes2.default.any,
  button: _propTypes2.default.any,
  rotateButton: _propTypes2.default.bool,
  childButtonDiam: _propTypes2.default.number,
  separationAngle: _propTypes2.default.number,
  flyOutRadius: _propTypes2.default.number,
  initAngle: _propTypes2.default.number,
  backlock: _propTypes2.default.bool
};

exports.default = IconMotionMenu;