'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_Component) {
  _inherits(Modal, _Component);

  function Modal(props) {
    _classCallCheck(this, Modal);

    var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

    _this.state = {
      close: false
    };
    _this._renderHeader = _this._renderHeader.bind(_this);
    _this._renderBody = _this._renderBody.bind(_this);
    _this._renderFooter = _this._renderFooter.bind(_this);
    _this.close = _this.close.bind(_this);
    return _this;
  }

  _createClass(Modal, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isOpen) {
        document.body.classList.add('modal-open');
      }
    }
  }, {
    key: '_renderHeader',
    value: function _renderHeader() {
      return _react2.default.createElement(
        _reactstrap.ModalHeader,
        { toggle: !this.props.noHeaderBtnClose && this.close },
        this.props.title
      );
    }
  }, {
    key: '_renderBody',
    value: function _renderBody() {
      return _react2.default.createElement(
        _reactstrap.ModalBody,
        null,
        this.props.titleBody && _react2.default.createElement(
          'p',
          null,
          this.props.titleBody
        ),
        this.props.children
      );
    }
  }, {
    key: '_renderFooter',
    value: function _renderFooter() {
      return _react2.default.createElement(
        _reactstrap.ModalFooter,
        null,
        this.props.preFooter,
        !this.props.noFooterBtnClose && _react2.default.createElement(
          _reactstrap.Button,
          {
            disabled: this.props.fetching,
            onClick: this.close,
            style: { marginRight: 5 }
          },
          'Cerrar'
        ),
        this.props.footer
      );
    }
  }, {
    key: 'close',
    value: function close() {
      var _this2 = this;

      if (this.props.animation.out) {
        this.setState({
          close: true
        }, function () {
          setTimeout(function () {
            _this2.props.close();
            _this2.setState({
              close: false
            });
          }, 300);
        });
      } else {
        this.props.close();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactstrap.Modal,
        {
          isOpen: this.props.isOpen,
          backdrop: 'static',
          size: this.props.size,
          className: (this.props.color ? 'modal-' + this.props.color : '') + (this.props.animation.in && !this.state.close ? ' animated ' + this.props.animation.in : ' ') + (this.props.animation.out && this.state.close ? ' animated ' + this.props.animation.out : ' ')
        },
        this.props.title && this._renderHeader(),
        this._renderBody(),
        !this.props.noFooter && this._renderFooter()
      );
    }
  }]);

  return Modal;
}(_react.Component);

Modal.defaultProps = {
  isOpen: false,
  noHeaderBtnClose: false,
  noFooterBtnClose: false,
  noFooter: false,
  size: 'md',
  animation: {}
};

Modal.propTypes = {
  size: _propTypes2.default.string,
  title: _propTypes2.default.string,
  titleBody: _propTypes2.default.string,
  color: _propTypes2.default.string,
  isOpen: _propTypes2.default.bool,
  noHeaderBtnClose: _propTypes2.default.bool,
  noFooterBtnClose: _propTypes2.default.bool,
  noFooter: _propTypes2.default.bool,
  fetching: _propTypes2.default.bool,
  close: _propTypes2.default.func.isRequired,
  children: _propTypes2.default.any,
  footer: _propTypes2.default.any,
  preFooter: _propTypes2.default.any,
  animation: _propTypes2.default.object
};

exports.default = Modal;