'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ANIMATING_START_RIGHT = 'StartRight';
var ANIMATING__END_RIGHT = 'EndRight';
var ANIMATING_START_LEFT = 'StartLeft';
var ANIMATING_END_LEFT = 'EndLeft';

var ModalMultiView = function (_Component) {
  _inherits(ModalMultiView, _Component);

  function ModalMultiView(props) {
    _classCallCheck(this, ModalMultiView);

    var _this = _possibleConstructorReturn(this, (ModalMultiView.__proto__ || Object.getPrototypeOf(ModalMultiView)).call(this, props));

    _this.state = { views: props.views, activeView: 0, animating: '' };
    _this._onCloseModal = _this._onCloseModal.bind(_this);
    _this._renderViews = _this._renderViews.bind(_this);
    _this._modalNextView = _this._modalNextView.bind(_this);
    _this._modalPrevView = _this._modalPrevView.bind(_this);
    return _this;
  }

  _createClass(ModalMultiView, [{
    key: '_onCloseModal',
    value: function _onCloseModal() {
      var _this2 = this;

      this.props.onClose();
      setTimeout(function () {
        return _this2.setState({ activeView: 0 });
      }, 1100);
    }
  }, {
    key: '_modalNextView',
    value: function _modalNextView(key) {
      var _this3 = this;

      if (typeof key === 'number' && !this.state.views[key]) {
        alert('la vista no existe'); //  eslint-disable-line
        return;
      }
      if (typeof key === 'number' && !this.props.viewsSize[key]) {
        alert('no se encuentra asignado el tamaño'); //  eslint-disable-line
        return;
      }
      this.setState({ animating: ANIMATING_START_LEFT }, function () {
        setTimeout(function () {
          var activeView = _this3.state.activeView + 1;
          if (typeof key === 'number') {
            activeView = key;
          }
          _this3.setState({ activeView: activeView, animating: ANIMATING__END_RIGHT });
        }, 1100);
        setTimeout(function () {
          return _this3.setState({ animating: '' });
        }, 2200);
      });
    }
  }, {
    key: '_modalPrevView',
    value: function _modalPrevView(key) {
      var _this4 = this;

      if (typeof key === 'number' && !this.state.views[key]) {
        alert('la vista no existe'); //  eslint-disable-line
        return;
      }
      if (typeof key === 'number' && !this.props.viewsSize[key]) {
        alert('no se encuentra asignado el tamaño'); //  eslint-disable-line
        return;
      }
      this.setState({ animating: ANIMATING_START_RIGHT }, function () {
        setTimeout(function () {
          var activeView = _this4.state.activeView - 1;
          if (typeof key === 'number') {
            activeView = key;
          }
          _this4.setState({ activeView: activeView, animating: ANIMATING_END_LEFT });
        }, 1100);
        setTimeout(function () {
          return _this4.setState({ animating: '' });
        }, 2200);
      });
    }
  }, {
    key: '_renderViews',
    value: function _renderViews(view, key) {
      return _react2.default.createElement(
        'wrapper',
        { key: key },
        this.state.activeView === key && view(this._modalNextView, this._modalPrevView, this.state.animating !== '', this._onCloseModal)
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactstrap.Modal,
        {
          backdrop: 'static',
          dialogClassName: 'modal-' + this.props.viewsSize[this.state.activeView] + ' ' + (this.state.animating === ANIMATING_START_LEFT ? 'modal-ModalMultiView' + ANIMATING_START_LEFT + '-' + this.props.viewsSize[this.state.activeView] : this.state.animating === ANIMATING__END_RIGHT ? 'modal-ModalMultiView' + ANIMATING__END_RIGHT + '-' + this.props.viewsSize[this.state.activeView] : this.state.animating === ANIMATING_START_RIGHT ? 'modal-ModalMultiView' + ANIMATING_START_RIGHT + '-' + this.props.viewsSize[this.state.activeView] : this.state.animating === ANIMATING_END_LEFT ? 'modal-ModalMultiView' + ANIMATING_END_LEFT + '-' + this.props.viewsSize[this.state.activeView] : null),
          show: this.props.showModal,
          onHide: this._onCloseModal
        },
        this.state.views.map(this._renderViews)
      );
    }
  }]);

  return ModalMultiView;
}(_react.Component);

ModalMultiView.defaultProps = {
  views: [],
  viewsSize: [],
  showModal: false
};

ModalMultiView.propTypes = {
  views: _propTypes2.default.array.isRequired,
  viewsSize: _propTypes2.default.array.isRequired,
  showModal: _propTypes2.default.bool,
  onClose: _propTypes2.default.func
};

exports.default = ModalMultiView;