'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _withTooltip = require('./withTooltip');

var _withTooltip2 = _interopRequireDefault(_withTooltip);

var _withColumnsTag = require('./withColumnsTag');

var _withColumnsTag2 = _interopRequireDefault(_withColumnsTag);

var _withSortLimitFilterPageFunctions = require('./withSortLimitFilterPageFunctions');

var _withSortLimitFilterPageFunctions2 = _interopRequireDefault(_withSortLimitFilterPageFunctions);

var _withLimit = require('./withLimit');

var _withLimit2 = _interopRequireDefault(_withLimit);

var _withFilter = require('./withFilter');

var _withFilter2 = _interopRequireDefault(_withFilter);

var _withSort = require('./withSort');

var _withSort2 = _interopRequireDefault(_withSort);

var _withPage = require('./withPage');

var _withPage2 = _interopRequireDefault(_withPage);

var _withPageDetail = require('./withPageDetail');

var _withPageDetail2 = _interopRequireDefault(_withPageDetail);

var _withMultiFilter = require('./withMultiFilter');

var _withMultiFilter2 = _interopRequireDefault(_withMultiFilter);

var _withPrint = require('./withPrint');

var _withPrint2 = _interopRequireDefault(_withPrint);

var _withTable = require('./withTable');

var _withTable2 = _interopRequireDefault(_withTable);

var _withFixHeader = require('./withFixHeader');

var _withFixHeader2 = _interopRequireDefault(_withFixHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Table, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'wrapper',
        {
          className: 'componentTable',
          style: _extends({ display: 'block' }, this.props.style)
        },
        this.props._renderMultiFilter(),
        (this.props.limit || this.props.filter) && _react2.default.createElement(
          _reactstrap.Row,
          { className: 'table_filtros' },
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12 mb-1', lg: '6' },
            this.props._renderLimit()
          ),
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12 mb-1', lg: '6' },
            this.props._renderFilter()
          )
        ),
        this.props._renderColumnsTag(),
        this.props.fixHeader && this.props._renderTableFixHeader(),
        !this.props.fixHeader && this.props._renderTable(),
        this.props.pagination && !this.props.fetching && _react2.default.createElement(
          _reactstrap.Row,
          null,
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '7' },
            this.props._renderPage()
          ),
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '5' },
            this.props._renderPageDetail()
          )
        ),
        (this.props.print || this.props.otherOptions) && !this.props.fetching && _react2.default.createElement(
          _reactstrap.Row,
          null,
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12' },
            this.props._renderPrintButton(),
            !this.props.popupWindow && this.props.otherOptions
          )
        ),
        this.props._renderPrint()
      );
    }
  }]);

  return Table;
}(_react.Component);

Table.defaultProps = {};

Table.propTypes = {
  // withColumnsTag
  _renderColumnsTag: _propTypes2.default.func,
  // withLimit
  _renderLimit: _propTypes2.default.func,
  // withFilter
  _renderFilter: _propTypes2.default.func,
  // withPage
  _renderPage: _propTypes2.default.func,
  // withPageDetail
  _renderPageDetail: _propTypes2.default.func,

  // withMultiFilter
  _renderMultiFilter: _propTypes2.default.func,
  // withPrint
  _renderPrintButton: _propTypes2.default.func,
  _renderPrint: _propTypes2.default.func,
  // withTable
  _renderTable: _propTypes2.default.func,
  // withFixHeader
  _renderTableFixHeader: _propTypes2.default.func,

  style: _propTypes2.default.object,
  filter: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object]),
  limit: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object]),
  pagination: _propTypes2.default.object,
  fixHeader: _propTypes2.default.bool,
  print: _propTypes2.default.bool,
  otherOptions: _propTypes2.default.any,
  popupWindow: _propTypes2.default.bool,
  fetching: _propTypes2.default.bool
};

exports.default = (0, _withTooltip2.default)((0, _withColumnsTag2.default)((0, _withSortLimitFilterPageFunctions2.default)((0, _withLimit2.default)((0, _withFilter2.default)((0, _withSort2.default)((0, _withPage2.default)((0, _withPageDetail2.default)((0, _withMultiFilter2.default)((0, _withPrint2.default)((0, _withTable2.default)((0, _withFixHeader2.default)(Table))))))))))));