'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withPage;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withPage(Component) {
  var withPage = function (_React$Component) {
    _inherits(withPage, _React$Component);

    function withPage(props) {
      _classCallCheck(this, withPage);

      var _this = _possibleConstructorReturn(this, (withPage.__proto__ || Object.getPrototypeOf(withPage)).call(this, props));

      var items = 0;
      if (props.tBodyObject.length !== 0 && props.pagination) {
        if (props.limit) {
          items = Math.ceil(props.pagination.total / props.activeLimit);
        } else if (props.pagination.perPage && props.pagination.total) {
          items = Math.ceil(props.pagination.total / props.pagination.perPage);
        }
      }

      _this.state = {
        items: items
      };
      _this.handlerOnChange = _this.handlerOnChange.bind(_this);
      _this._renderPage = _this._renderPage.bind(_this);
      return _this;
    }

    _createClass(withPage, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.props.pagination.init) {
          this.props.setActivePage(1);
        }
        if (this.props.pagination.restart && this.props.pagination.returnRestart) {
          this.props.pagination.returnRestart();
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.tBodyObject.length !== 0 && nextProps.pagination) {
          var items = 0;
          if (nextProps.limit) {
            items = Math.ceil(nextProps.pagination.total / nextProps.activeLimit);
          } else if (nextProps.pagination.perPage && nextProps.pagination.total) {
            items = Math.ceil(nextProps.pagination.total / nextProps.pagination.perPage);
          }
          this.setState({
            items: items
          });
        }
        if (nextProps.pagination.restart && nextProps.pagination.returnRestart) {
          nextProps.setActivePage(1);
          nextProps.pagination.returnRestart();
        }
      }
    }, {
      key: 'handlerOnChange',
      value: function handlerOnChange(activePage) {
        if (activePage !== this.props.activePage) {
          this.props.setActivePage(activePage);
        }
      }
    }, {
      key: '_renderPage',
      value: function _renderPage() {
        if (this.props.pagination && !this.props.fetching && this.props.tBodyObject.length !== 0 && this.state.items !== 0) {
          return _react2.default.createElement(
            'nav',
            null,
            _react2.default.createElement(_reactBootstrap.Pagination, _extends({}, this.props.pagination.configPagination, {
              items: this.state.items,
              activePage: this.props.activePage,
              onSelect: this.handlerOnChange
            }))
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({
          _renderPage: this._renderPage
        }, this.props));
      }
    }]);

    return withPage;
  }(_react2.default.Component);

  withPage.defaultProps = {
    pagination: { init: false },
    tBodyObject: [],
    fetching: false
  };

  withPage.propTypes = {
    pagination: _propTypes2.default.object,
    tBodyObject: _propTypes2.default.array,
    fetching: _propTypes2.default.bool,
    activePage: _propTypes2.default.number,
    activeLimit: _propTypes2.default.number,
    setActivePage: _propTypes2.default.func,
    limit: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object])
  };

  return withPage;
}